#rm(list=ls(all=TRUE))
#my.work.computer=F;

#if(my.work.computer){setwd("C:\\Users\\philb\\Desktop\\Dissertation\\Chapter2\\AffyDatasets")}

keep.genes = sort(substr(colnames(read.csv('selectedgenes.csv')[-1]),7,20))

#####
#Read in raw training pcr data
#####

row.names = scan('TrainingRawPCR.csv',what=c(rep(list(NULL), 4),list('character'),rep(list(NULL),48)),sep = ",", quote="\"",flush=T,skip=3,nlines=378)[[5]]
training.raw = data.frame(do.call("cbind",scan('TrainingRawPCR.csv',what=c(rep(list(NULL), 6),rep(list(double(0)),47)),na.strings='Undetermined',sep = ",", quote="\"",flush=T,skip=3,nlines=378)),
			row.names=row.names)
colnames(training.raw) = colnames(read.csv('TrainingRawPCR.csv',nrows=1))[-(1:6)]
colnames(training.raw) = sub('A0','A',colnames(training.raw))

training.18s = data.frame(do.call("cbind",scan('TrainingRawPCR.csv',what=c(rep(list(NULL), 6),rep(list(double(0)),47)),na.strings='Undetermined',sep = ",", quote="\"",flush=T,skip=380,nlines=4)))
colnames(training.18s) = colnames(training.raw)
rownames(training.18s) = c('18s1','18s2','18s3','18s4')

training.raw = training.raw[,order(colnames(training.raw))]
training.18s = training.18s[,colnames(training.raw)]
training.raw = training.raw[keep.genes,]

###
#Read in raw validation pcr data
####

row.names = scan('ValidationRawPCR.csv',what=c(rep(list(NULL), 3),list('character'),rep(list(NULL),129)),sep = ",", quote="\"",flush=T,skip=6,nlines=92)[[4]]
validation.raw = data.frame(do.call("cbind",scan('ValidationRawPCR.csv',what=c(rep(list(NULL), 13),rep(list(double(0)),133-13)),sep = ",", quote="\"",flush=T,skip=6,nlines=92)),
			row.names=row.names)
colnames(validation.raw) = colnames(read.csv('ValidationRawPCR.csv',nrows=1,skip=4))[-(1:13)]

validation.18s = data.frame(do.call("cbind",scan('ValidationRawPCR.csv',what=c(rep(list(NULL), 13),rep(list(double(0)),133-13)),sep = ",", quote="\"",flush=T,skip=98,nlines=2)))
rownames(validation.18s) = c('18s1','18s2')
colnames(validation.18s) = colnames(validation.raw)

valid.samples.to.keep = sort(colnames(read.csv('ValidationNormPCR.csv'))[-1])
validation.raw = validation.raw[,valid.samples.to.keep]
validation.18s = validation.18s[,colnames(validation.raw)]
validation.raw = validation.raw[keep.genes,]


##########
#Normalize and shape the pcr data according to the prescription in 
#supplementary materials of Chen, et al (Journal of Thoracic Oncology, Vol. 6, Sep., 2011)
#########
foo = t(t(training.raw)-colMeans(training.18s))
avg.resid = t(t(foo)-rowMeans(training.raw,na.rm=T))
xa = t(foo)-rowMeans(avg.resid,na.rm=T)

foo = t(t(validation.raw)-colMeans(validation.18s))
avg.resid = t(t(foo)-rowMeans(validation.raw,na.rm=T))
x.new = t(t(foo)-rowMeans(avg.resid,na.rm=T))

#There is a location shift between the training and validation data
#The following step accounts for this. This was not discussed in the original
#JTO paper by Chen, et al. 
x.new = t(x.new + mean(apply(xa,2,median,na.rm=T)-apply(x.new,1,median,na.rm=T)))
colnames(xa) = colnames(x.new) = paste('pcr_',colnames(xa),sep='')


####
#Read in affymetrix data
####
foo = read.csv('affy_pcr.csv',row.names=2)
training.affy = foo[,paste('affy_un_',keep.genes,sep='')]
groupA = which(rowSums(!is.na(foo[,paste('pcr_n_',keep.genes,sep='')]))!=0)
groupB = which(rowSums(!is.na(foo[,paste('pcr_n_',keep.genes,sep='')]))==0)

wa = log(training.affy[groupA,])
wb = log(training.affy[groupB,])
colnames(wa) = colnames(wb) = paste('affy_',substr(colnames(xa),5,20),sep='')

####
#Create missing data matrices
####
xb = matrix(NA,dim(wb)[1],dim(wb)[2]);colnames(xb)=colnames(xa);rownames(xb)=rownames(wb);
w.new = matrix(NA,dim(x.new)[1],dim(x.new)[2]);colnames(w.new)=colnames(wa);rownames(w.new)=rownames(x.new);


####
#Read in survival times, censoring indicators, and clinical covariates
#####
ya = foo[groupA,c('all.time','All.event_Dead_1')];ya[,1] = log(ya[,1])
yb = foo[groupB,c('all.time','All.event_Dead_1')];yb[,1] = log(yb[,1])

n.a = length(groupA);n.b = length(groupB)
ya = cbind(ya,1,0,1)
yb = cbind(yb,0,1,1)
colnames(ya)=colnames(yb)=c('logtime','event','A','B','training')

#0 = FEMALE, 1 = MALE
colnames.clinical = c("AGE","STAGE","GENDER")
za = foo[groupA,colnames.clinical]
zb = foo[groupB,colnames.clinical]


foo = read.csv('GuoanSurvival.csv',header=T,skip=2,row.names=1,nrows=101)
rownames(foo) = substr(rownames(foo),1,4)
y.new = foo[,c('Survival.time12_11_09','dead.alive')];y.new[,1]=log(y.new[,1]);y.new[,2]=as.numeric(y.new[,2]=='dead')
y.new = cbind(y.new,0,0,0)
colnames(y.new) = colnames(ya)


colnames.clinical = c("AGE","STAGE","SEX")
foo$STAGE = unlist(strsplit(unlist(strsplit(as.character(foo$STAGE),'a')),'b'))
foo$STAGE[foo$STAGE=='1']='I'
foo$STAGE[foo$STAGE=='IV']='III'	
foo$STAGE = as.numeric(as.roman(foo$STAGE))
foo$SEX = as.numeric(foo$SEX=='M')
z.new = foo[,colnames.clinical]
colnames(z.new) = colnames(za)


all.data = rbind(cbind(ya,za,xa,wa),cbind(yb,zb,xb,wb),cbind(y.new,z.new,x.new,w.new))
rm(list=setdiff(ls(),c("all.data","my.work.computer")))

#if(my.work.computer){setwd("C:\\Users\\philb\\Desktop\\Dissertation\\Chapter2")}
